angular.module('beamng.apps')
.directive('saber', ['StreamsManager', function (StreamsManager) {
  return {
    template:
        '<object class="bngApp" style="width:100%; height:100%; pointer-events: none" type="image/svg+xml" data="modules/apps/Saber/saber.svg"></object>',
    replace: true,
    restrict: 'EA',
    link: function (scope, element, attrs) {
      StreamsManager.add(['electrics']);

      scope.$on('$destroy', function () {
        StreamsManager.remove(['electrics']);
      });

      element.on('load', function () {
        var svg    = element[0].contentDocument
          , throttleRL = { bar: svg.getElementById('filler0'), barneg: svg.getElementById('filler0neg'), txt: svg.getElementById('txt0'), val: svg.getElementById('val0'), factor: svg.getElementById('container0').getAttribute('height') / 200.0 }
          , throttleFL = { bar: svg.getElementById('filler1'), barneg: svg.getElementById('filler1neg'), txt: svg.getElementById('txt1'), val: svg.getElementById('val1'), factor: svg.getElementById('container1').getAttribute('height') / 200.0 }
          , throttleFR = { bar: svg.getElementById('filler2'), barneg: svg.getElementById('filler2neg'), txt: svg.getElementById('txt2'), val: svg.getElementById('val2'), factor: svg.getElementById('container2').getAttribute('height') / 200.0 }
          , throttleRR = { bar: svg.getElementById('filler3'), barneg: svg.getElementById('filler3neg'), txt: svg.getElementById('txt3'), val: svg.getElementById('val3'), factor: svg.getElementById('container3').getAttribute('height') / 200.0 }
        ;

        scope.$on('streamsUpdate', function (event, streams) {
          if (streams != null && streams.electrics != null) {
              
			  var throttleRLVal = Math.round(streams.electrics.saberData.RL * 100)
                , throttleFLVal = Math.round(streams.electrics.saberData.FL * 100)
                , throttleFRVal = Math.round(streams.electrics.saberData.FR * 100)
                , throttleRRVal = Math.round(streams.electrics.saberData.RR * 100)
              ;

              throttleRL.val.innerHTML = throttleRLVal;
              throttleFL.val.innerHTML = throttleFLVal;
              throttleFR.val.innerHTML = throttleFRVal;
              throttleRR.val.innerHTML = throttleRRVal;

              throttleRL.txt.innerHTML = "RL";
              throttleFL.txt.innerHTML = "FL";
              throttleFR.txt.innerHTML = "FR";
              throttleRR.txt.innerHTML = "RR";
				
			  barHeightRL = throttleRLVal * throttleRL.factor
			  barHeightFL = throttleFLVal * throttleFL.factor
			  barHeightFR = throttleFRVal * throttleFR.factor
			  barHeightRR = throttleRRVal * throttleRR.factor
			  
              throttleRL.bar.setAttribute('height', isNaN(throttleRLVal) ? 0 : barHeightRL);
              throttleFL.bar.setAttribute('height', isNaN(throttleFLVal) ? 0 : barHeightFL);
              throttleFR.bar.setAttribute('height', isNaN(throttleFRVal) ? 0 : barHeightFR);
              throttleRR.bar.setAttribute('height', isNaN(throttleRRVal) ? 0 : barHeightRR);
			  
			  
			  throttleRL.barneg.setAttribute('height', isNaN(throttleRLVal) ? 0 : -barHeightRL);
              throttleFL.barneg.setAttribute('height', isNaN(throttleFLVal) ? 0 : -barHeightFL);
              throttleFR.barneg.setAttribute('height', isNaN(throttleFRVal) ? 0 : -barHeightFR);
              throttleRR.barneg.setAttribute('height', isNaN(throttleRRVal) ? 0 : -barHeightRR);
			  
			  // parseFloat to allow addition because this is a garbage language
			  throttleRL.barneg.setAttribute('y', isNaN(throttleRLVal) ? throttleRL.bar.getAttribute('y') : parseFloat(throttleRL.bar.getAttribute('y')) + barHeightRL);
			  throttleFL.barneg.setAttribute('y', isNaN(throttleFLVal) ? throttleFL.bar.getAttribute('y') : parseFloat(throttleFL.bar.getAttribute('y')) + barHeightFL);
			  throttleFR.barneg.setAttribute('y', isNaN(throttleFRVal) ? throttleFR.bar.getAttribute('y') : parseFloat(throttleFR.bar.getAttribute('y')) + barHeightFR);
			  throttleRR.barneg.setAttribute('y', isNaN(throttleRRVal) ? throttleRR.bar.getAttribute('y') : parseFloat(throttleRR.bar.getAttribute('y')) + barHeightRR);
			  
          }
        });
      });
    }
  };
}]);
